# TODO:
# spec file needs cleanup

%global bootstrap 0

%global homedir %{_datadir}/%{name}
%global webroot %{homedir}/webroot
%global corepluginsdir %{webroot}/WEB-INF/plugins
%global workdir %{_sharedstatedir}/%{name}
%global juid    175

Name:           jenkins
Version:        1.590
Release:        3%{?dist}
Summary:        An extendable open source continuous integration server

# The project's primary license is MIT
# ASL 2.0:
# few files in core/src/main/java/hudson/
# CDDL:
# core/src/main/java/hudson/util/EditDistance.java
# LGPLv2+:
# few files in core/src/main/java/hudson/util/jna/
License:        MIT and ASL 2.0 and LGPLv2+ and CDDL
URL:            http://jenkins-ci.org
Source0:        https://github.com/jenkinsci/jenkins/archive/%{name}-%{version}.tar.gz
Source1:        http://www.apache.org/licenses/LICENSE-2.0.txt
# taken from https://netbeans.org/cddl-gplv2.html
Source2:        CDDL-LICENSE
Source4:        jenkins-sysconfig
Source6:        jenkins.service
Source7:        jenkins.init
Source8:        dependencies.txt

Patch101:       0001-SECURITY-162-Capture-the-root-directory-in-VirtualFi.patch
Patch102:       0002-SECURITY-163-Treat-BadPaddingException-as-an-unloada.patch
Patch103:       0003-SECURITY-165-blacklist-the-document-xpath-function-f.patch
Patch104:       0004-SECURITY-166-Prevent-the-creation-of-anonymous-syste.patch
Patch105:       0005-SECURITY-167-defend-against-XXE-attacks.patch
Patch106:       0006-SECURITY-125-Preventing-cyclic-dependencies-among-bu.patch
Patch107:       0007-SECURITY-171-XSS-in-FormValidation._error-.-Throwabl.patch
Patch108:       0008-SECURITY-177-Reflected-XSS-in-AdjunctManager.doDynam.patch
Patch109:       0009-SECURITY-180-arbitrary-API-Token-change-leak-via-cha.patch

# animal sniffer is not really useful in Fedora
Patch1:         remove-animal-sniffer-annotations.patch
#Patch2:         remove-support-for-solaris.patch
# we don't need support for Solaris in SU
Patch3:         remove-solaris-support-in-su.patch
# jna-posix library is not in Fedora, we use jnr-posix
Patch4:         drop-jna-posix-compatibility.patch
# newer args4j
Patch6:         use-args4j-2.0.25.patch
# build against newer guava
Patch7:         use-guava-13.0.patch
Patch9:         remove-windows-support-from-processtree.patch
Patch10:        remove-dotnet-support.patch
Patch11:        remove-windows-installer-support.patch
Patch13:        add-support-for-plugins-from-RPMs.patch
Patch14:        do-not-check-for-core-updates.patch

BuildArch:      noarch

BuildRequires:  maven-local
BuildRequires:  mvn(antlr:antlr)
BuildRequires:  mvn(args4j:args4j)
BuildRequires:  mvn(com.github.jnr:jnr-posix)
BuildRequires:  mvn(com.google.code.findbugs:jsr305)
BuildRequires:  mvn(com.google.guava:guava)
BuildRequires:  mvn(com.google.inject:guice::no_aop:)
BuildRequires:  mvn(com.infradna.tool:bridge-method-annotation)
BuildRequires:  mvn(com.infradna.tool:bridge-method-injector)
BuildRequires:  mvn(com.jcraft:jzlib)
BuildRequires:  mvn(commons-beanutils:commons-beanutils)
BuildRequires:  mvn(commons-codec:commons-codec)
BuildRequires:  mvn(commons-collections:commons-collections)
BuildRequires:  mvn(commons-digester:commons-digester)
BuildRequires:  mvn(commons-httpclient:commons-httpclient)
BuildRequires:  mvn(commons-io:commons-io)
BuildRequires:  mvn(commons-jelly:commons-jelly-tags-define)
BuildRequires:  mvn(commons-jelly:commons-jelly-tags-fmt)
BuildRequires:  mvn(commons-jelly:commons-jelly-tags-xml)
BuildRequires:  mvn(commons-lang:commons-lang)
BuildRequires:  mvn(commons-logging:commons-logging)
BuildRequires:  mvn(com.sun.xml.txw2:txw2)
BuildRequires:  mvn(javax.mail:mail)
BuildRequires:  mvn(javax.servlet:jstl)
BuildRequires:  mvn(javax.servlet:servlet-api)
BuildRequires:  mvn(jaxen:jaxen)
BuildRequires:  mvn(jline:jline:1)
BuildRequires:  mvn(junit:junit)
BuildRequires:  mvn(net.java.dev.jna:jna)
BuildRequires:  mvn(net.java.sezpoz:sezpoz)
BuildRequires:  mvn(org.apache.ant:ant)
BuildRequires:  mvn(org.apache.maven.plugins:maven-release-plugin)
BuildRequires:  mvn(org.codehaus.groovy:groovy18:1.8)
BuildRequires:  mvn(org.codehaus.mojo:antlr-maven-plugin)
BuildRequires:  mvn(org.codehaus.mojo:build-helper-maven-plugin)
BuildRequires:  mvn(org.fusesource.jansi:jansi)
BuildRequires:  mvn(org.jenkins-ci:annotation-indexer)
BuildRequires:  mvn(org.jenkins-ci:bytecode-compatibility-transformer)
BuildRequires:  mvn(org.jenkins-ci:commons-jexl)
BuildRequires:  mvn(org.jenkins-ci:crypto-util)
BuildRequires:  mvn(org.jenkins-ci:jmdns)
BuildRequires:  mvn(org.jenkins-ci:memory-monitor)
BuildRequires:  mvn(org.jenkins-ci:task-reactor)
BuildRequires:  mvn(org.jenkins-ci.tools:maven-hpi-plugin)
BuildRequires:  mvn(org.jenkins-ci:version-number)
BuildRequires:  mvn(org.jfree:jfreechart)
BuildRequires:  mvn(org.jvnet.hudson:xstream)
BuildRequires:  mvn(org.jvnet.localizer:localizer)
BuildRequires:  mvn(org.jvnet.localizer:maven-localizer-plugin)
BuildRequires:  mvn(org.jvnet.robust-http-client:robust-http-client)
BuildRequires:  mvn(org.kohsuke:access-modifier-annotation)
BuildRequires:  mvn(org.kohsuke:access-modifier-checker)
BuildRequires:  mvn(org.kohsuke:akuma)
BuildRequires:  mvn(org.kohsuke:libpam4j)
BuildRequires:  mvn(org.kohsuke.metainf-services:metainf-services)
BuildRequires:  mvn(org.kohsuke.stapler:json-lib)
BuildRequires:  mvn(org.kohsuke.stapler:maven-stapler-plugin)
BuildRequires:  mvn(org.kohsuke.stapler:stapler-adjunct-timeline)
BuildRequires:  mvn(org.kohsuke.stapler:stapler-groovy)
BuildRequires:  mvn(org.kohsuke:trilead-putty-extension)
BuildRequires:  mvn(org.mindrot:jbcrypt)
BuildRequires:  mvn(org.mockito:mockito-core)
BuildRequires:  mvn(org.powermock:powermock-api-mockito)
BuildRequires:  mvn(org.powermock:powermock-module-junit4)
BuildRequires:  mvn(org.springframework.ldap:spring-ldap-core)
BuildRequires:  mvn(org.springframework.ldap:spring-ldap-core-tiger)
BuildRequires:  mvn(org.springframework.ldap:spring-ldap-ldif-batch)
BuildRequires:  mvn(org.springframework.ldap:spring-ldap-ldif-core)
BuildRequires:  mvn(org.springframework.ldap:spring-ldap-odm)
BuildRequires:  mvn(org.springframework.security:spring-security-acl)
BuildRequires:  mvn(org.springframework.security:spring-security-config)
BuildRequires:  mvn(org.springframework.security:spring-security-core)
BuildRequires:  mvn(org.springframework.security:spring-security-ldap)
BuildRequires:  mvn(org.springframework.security:spring-security-web)
BuildRequires:  mvn(org.springframework:spring-aop)
BuildRequires:  mvn(org.springframework:spring-core)
BuildRequires:  mvn(org.springframework:spring-webmvc)
BuildRequires:  mvn(org.tmatesoft.svnkit:trilead-ssh2)
BuildRequires:  mvn(org.jenkins-ci.main:remoting)
BuildRequires:  mvn(xpp3:xpp3)
BuildRequires:  mvn(org.apache.maven.plugins:maven-war-plugin)
BuildRequires:  mvn(org.apache.sshd:sshd-core)
BuildRequires:  mvn(org.bouncycastle:bcprov-jdk16)
BuildRequires:  mvn(org.bouncycastle:bcpkix-jdk15on)
BuildRequires:  mvn(org.acegisecurity:acegi-security)
BuildRequires:  mvn(org.kohsuke.stapler:stapler-adjunct-codemirror)
BuildRequires:  mvn(org.jenkins-ci.plugins.icon-shim:icon-set)
BuildRequires:  mvn(org.jenkins-ci:winstone)
BuildRequires:  mvn(net.jcip:jcip-annotations)
BuildRequires:  systemd-units
%if !%{bootstrap}
#BuildRequires:  mvn(org.jenkins-ci.lib:lib-jenkins-maven-embedder)
BuildRequires:  mvn(org.jenkins-ci.main:cli)
BuildRequires:  mvn(org.jenkins-ci:executable-war)
BuildRequires:  mvn(org.jenkins-ci.main:jenkins-core)
#BuildRequires:  mvn(org.jenkins-ci.main.maven:maven31-agent)
#BuildRequires:  mvn(org.jenkins-ci.main.maven:maven31-interceptor)
#BuildRequires:  mvn(org.jenkins-ci.main:pom:pom:)
BuildRequires:  mvn(org.jenkins-ci.modules:instance-identity)
#BuildRequires:  mvn(org.jenkins-ci.modules:slave-installer)
BuildRequires:  mvn(org.jenkins-ci.modules:ssh-cli-auth)
BuildRequires:  mvn(org.jenkins-ci.modules:sshd)
#BuildRequires:  mvn(org.jenkins-ci.plugins:credentials)
#BuildRequires:  mvn(org.jenkins-ci.plugins:javadoc)
#BuildRequires:  mvn(org.jenkins-ci.plugins:mailer)
#BuildRequires:  mvn(org.jenkins-ci.plugins:ssh-credentials)
#BuildRequires:  mvn(org.jenkins-ci.plugins:token-macro)
BuildRequires:  js-yui2
BuildRequires:  tomcat
%endif

Requires:         jenkins-webapp
Requires:         tomcat
Requires(pre):    shadow-utils
Requires(post):   systemd-units
Requires(preun):  systemd-units
Requires(postun): systemd-units


%description
Jenkins is an award-winning application that monitors executions of repeated
jobs, such as building a software project or jobs run by cron. Among those
things, current Jenkins focuses on the following two jobs:

- building/testing software projects continuously. In a nutshell, Jenkins
  provides an easy-to-use so-called continuous integration system, making it
  easier for developers to integrate changes to the project, and making it
  easier for users to obtain a fresh build. The automated, continuous build
  increases the productivity.

- monitoring executions of externally-run jobs, such as cron jobs and procmail
  jobs, even those that are run on a remote machine. For example, with cron, all
  you receive is regular e-mails that capture the output, and it is up to you to
  look at them diligently and notice when it broke. Jenkins keeps those outputs
  and makes it easy for you to notice when something is wrong.


%package core
Summary:        Jenkins core

%description core
This package contains Jenkins core artifact.

%package plugins-pom
Summary:        Jenkins Plugins POM

%description plugins-pom
This package contains Jenkins Plugins POM.

%package cli
Summary:        Jenkins CLI

%description cli
This package contains Jenkins CLI.

%if !%{bootstrap}
%package webapp
Summary:        Jenkins Web Application
# we install exploded WAR with symlinks to system JARs
Requires:       %{name} = %{version}-%{release}
Requires:       %{name}-core = %{version}-%{release}
Requires:       xpp3
Requires:       slf4j-jdk14
Requires:       jansi-native
Requires:       stapler-adjunct-timeline
Requires:       apache-sshd
Requires:       xpp3-minimal
Requires:       bouncycastle
Requires:       easymock
Requires:       jline1
Requires:       objectweb-asm
Requires:       jaxen
Requires:       jnr-constants
Requires:       springframework-tx
Requires:       apache-mina
Requires:       javamail
Requires:       args4j
Requires:       txw2
Requires:       aopalliance
Requires:       localizer
Requires:       constant-pool-scanner
Requires:       dom4j
Requires:       springframework-security
Requires:       tiger-types
Requires:       jenkins-remoting
Requires:       apache-commons-discovery
Requires:       log4j
Requires:       jenkins-version-number
Requires:       objectweb-asm
Requires:       guava
Requires:       bytecode-compatibility-transformer
Requires:       apache-commons-pool
Requires:       apache-commons-codec
Requires:       bouncycastle
Requires:       springframework-beans
Requires:       jfreechart
Requires:       spring-ldap
Requires:       groovy18
Requires:       findbugs
Requires:       apache-commons-lang
Requires:       xml-commons-apis
Requires:       atinject
Requires:       jcodings
Requires:       jakarta-commons-httpclient
Requires:       hawtjni
Requires:       jenkins-sshd
Requires:       ant
Requires:       objectweb-asm
Requires:       tomcat-jsp-2.2-api
Requires:       jcommon
Requires:       geronimo-interceptor
Requires:       relaxngDatatype
Requires:       spring-ldap
Requires:       spring-ldap
Requires:       jnr-posix
Requires:       tomcat-el-2.2-api
Requires:       bridge-method-injector
Requires:       google-guice
Requires:       jakarta-taglibs-standard
Requires:       apache-commons-cli
Requires:       apache-commons-digester
Requires:       jnr-ffi
Requires:       jna >= 4.1.0-7
Requires:       objectweb-asm
Requires:       stapler-jelly
Requires:       hamcrest
Requires:       akuma
Requires:       jBCrypt
Requires:       springframework-security
Requires:       springframework
Requires:       cglib
Requires:       jettison
Requires:       bytelist
Requires:       springframework-context
Requires:       jenkins-json-lib
Requires:       h2
Requires:       apache-commons-io
Requires:       springframework-security
Requires:       robust-http-client
Requires:       sezpoz
Requires:       apache-commons-jexl
Requires:       xerces-j2
Requires:       trilead-putty-extension
Requires:       springframework-expression
Requires:       jenkins-ssh-cli-auth
Requires:       groovy18
Requires:       jenkins-instance-identity
Requires:       freemarker
Requires:       annotation-indexer
Requires:       apache-commons-beanutils
Requires:       springframework-security
Requires:       jenkins-xstream
Requires:       jffi
Requires:       springframework-batch
Requires:       bouncycastle-pkix
Requires:       apache-commons-logging
Requires:       jansi
Requires:       objenesis
Requires:       jsr-305
Requires:       jenkins-extras-memory-monitor
Requires:       objectweb-asm
Requires:       ant
Requires:       access-modifier-annotation
Requires:       jenkins-jexl
Requires:       libpam4j
Requires:       cglib
Requires:       spring-ldap
Requires:       springframework-webmvc
Requires:       springframework-aop
Requires:       spring-ldap
Requires:       slf4j
Requires:       trilead-ssh2
Requires:       springframework-batch
Requires:       jzlib
Requires:       tomcat-servlet-3.0-api
Requires:       springframework-web
Requires:       jenkins-commons-jelly
Requires:       antlr-tool
Requires:       jmdns
Requires:       stapler
Requires:       jenkins-task-reactor
Requires:       junit
Requires:       springframework-jdbc
Requires:       jenkins-commons-jelly
Requires:       springframework-security
Requires:       jnr-x86asm
Requires:       hibernate-jpa-2.0-api
Requires:       jenkins-commons-jelly
Requires:       ezmorph
Requires:       springframework-security
Requires:       istack-commons
Requires:       jboss-connector-1.7-api
Requires:       apache-commons-fileupload
Requires:       jenkins-commons-jelly
Requires:       bea-stax-api
Requires:       stapler-groovy
Requires:       apache-commons-collections
Requires:       jenkins-crypto-util
Requires:       glassfish-jaxb
Requires:       geronimo-validation
Requires:       acegisecurity
Requires:       stapler-adjunct-codemirror
Requires:       jenkins-icon-shim
Requires:       jetty8
Requires:       jenkins-winstone
Requires:       jenkins-executable-war
Requires:       jenkins-javadoc-plugin
Requires:       jenkins-external-monitor-job-plugin
Requires:       jenkins-ant-plugin
Requires:       jenkins-mailer-plugin
Requires:       jenkins-junit-plugin
Requires:       jenkins-ssh-slaves-plugin
Requires:       jenkins-ssh-credentials-plugin
Requires:       jenkins-credentials-plugin
Requires:       js-yui2-jenkins
Requires:       jenkins-remoting-webapp
Requires:       jenkins-matrix-project-plugin

%description webapp
This package contains Jenkins Web Application.
%endif # bootstrap

%package javadoc
Summary:        Javadoc for %{name}

%description javadoc
This package contains API documentation for %{name}.


%prep
%setup -q -n %{name}-%{name}-%{version}

%patch101 -p1
%patch102 -p1
%patch103 -p1
%patch104 -p1
%patch105 -p1
%patch106 -p1
%patch107 -p1
%patch108 -p1
%patch109 -p1

%patch1 -p1
%patch3 -p1
%patch4 -p1
%patch6 -p1
%patch7 -p1
%patch9 -p1
%patch10 -p1
%patch11 -p1
%patch13 -p1 -F2
%patch14 -p1

# Remove bundled JARs and classes
find . -name "*.jar" -delete
find . -name "*.class" -delete

# remove support for Solaris for now (missing deps and unclear licensing)
rm core/src/main/java/hudson/os/solaris/package-info.java
rm core/src/main/java/hudson/os/solaris/ZFSProvisioner.java
rm core/src/main/java/hudson/os/solaris/ZFSInstaller.java

# remove windows support (for now)
rm core/src/main/java/hudson/util/jna/Advapi32.java
rm core/src/main/java/hudson/util/jna/RegistryKey.java
rm core/src/main/java/hudson/util/jna/SHELLEXECUTEINFO.java
rm core/src/main/java/hudson/util/jna/Shell32.java
rm core/src/main/java/hudson/util/jna/WINBASE.java

sed -i 's|org.kohsuke.asm5|org.objectweb.asm|g' core/src/main/java/hudson/util/SubClassGenerator.java

# Don't add classpath entry to the manifest
%pom_xpath_remove pom:manifest/pom:addClasspath core

cp %{SOURCE1} LICENSE-ASL-2.0.txt
cp %{SOURCE2} LICENSE-CDDL.txt

# packaging layout
%mvn_package :jenkins-core core
%mvn_package :plugin plugins-pom
%mvn_package :cli cli
%mvn_package :pom core

%if %{bootstrap}
%pom_disable_module war
%else
%mvn_package :jenkins-war __noinstall
%endif

# Jenkins uses its own fork of xstream
%pom_change_dep -r org.kohsuke.stapler:json-lib : core '
<exclusions>
    <exclusion>
        <groupId>com.thoughtworks.xstream</groupId>
        <artifactId>xstream</artifactId>
    </exclusion>
</exclusions>'
%pom_change_dep org.kohsuke.stapler:stapler-groovy : core '
<exclusions>
    <exclusion>
        <groupId>com.thoughtworks.xstream</groupId>
        <artifactId>xstream</artifactId>
    </exclusion>
</exclusions>'
%pom_change_dep org.acegisecurity:acegi-security : core '
<exclusions>
  <exclusion>
    <groupId>org.springframework</groupId>
    <artifactId>spring-remoting</artifactId>
  </exclusion>
  <exclusion>
    <groupId>org.springframework</groupId>
    <artifactId>spring-support</artifactId>
  </exclusion>
  <exclusion>
    <groupId>org.springframework</groupId>
    <artifactId>spring-context</artifactId>
  </exclusion>
  <exclusion>
    <groupId>org.springframework</groupId>
    <artifactId>spring-test</artifactId>
  </exclusion>
  <exclusion>
    <groupId>com.thoughtworks.xstream</groupId>
    <artifactId>xstream</artifactId>
  </exclusion>
  <exclusion>
    <groupId>com.sun</groupId>
    <artifactId>tools</artifactId>
  </exclusion>
</exclusions>'

# spring-aop pulls in a lot of tomcat libs, these will be provided by tomcat itself
%pom_change_dep org.springframework:spring-aop : core '
<exclusions>
    <exclusion>
        <groupId>org.apache.tomcat</groupId>
        <artifactId>tomcat-catalina</artifactId>
    </exclusion>
</exclusions>'

%pom_change_dep org.springframework:spring-webmvc : core '
<exclusions>
  <exclusion>
    <groupId>com.sun</groupId>
    <artifactId>tools</artifactId>
  </exclusion>
  <exclusion>
    <groupId>org.codehaus.groovy</groupId>
    <artifactId>groovy</artifactId>
  </exclusion>
  <exclusion>
    <groupId>com.thoughtworks.xstream</groupId>
    <artifactId>xstream</artifactId>
  </exclusion>
  <exclusion>
    <groupId>org.slf4j</groupId>
    <artifactId>slf4j-log4j12</artifactId>
  </exclusion>
  <exclusion>
    <groupId>org.slf4j</groupId>
    <artifactId>jcl-over-slf4j</artifactId>
  </exclusion>
</exclusions>'


# quick fix for newer version of jenkins-remoting
# this is already fixed upstream in newer Jenkins
sed -i 's|protected synchronized void terminate(|public synchronized void terminate(|g' core/src/main/java/hudson/Launcher.java
sed -i 's|protected synchronized void terminate(|public synchronized void terminate(|g' core/src/main/java/hudson/slaves/Channels.java

%pom_change_dep org.jenkins-ci:winstone :::compile war

# CLI uber JAR
# useful, but bundling exception will be needed
%pom_remove_plugin :maven-assembly-plugin cli

# Requires cannot be generated on jenkins-war (when building in bootstrap mode)
%pom_remove_dep org.jenkins-ci.main:jenkins-war plugins

# parent pom has not been packaged yet (licensing issues)
%pom_remove_parent
%pom_remove_parent plugins

# a lot of missing deps for tests
%pom_disable_module test

%pom_add_dep net.jcip:jcip-annotations core

# remove unneeded/unavailable stuff
%pom_xpath_remove "pom:extensions[pom:extension[pom:artifactId[text()='wagon-gitsite']]]"
%pom_xpath_remove "pom:extensions[pom:extension[pom:artifactId[text()='wagon-gitsite']]]" plugins
%pom_xpath_remove "pom:dependencies[pom:dependency[pom:artifactId[text()='maven-jellydoc-plugin']]]"
%pom_remove_plugin :animal-sniffer-maven-plugin
%pom_remove_plugin :gmaven-plugin
%pom_remove_plugin :maven-enforcer-plugin
%pom_remove_plugin :maven-remote-resources-plugin
%pom_remove_plugin org.codehaus.gmaven:gmaven-plugin plugins
%pom_remove_plugin org.codehaus.gmaven:gmaven-plugin core
%pom_remove_plugin org.jvnet.hudson.tools:maven-encoding-plugin core
%pom_remove_plugin com.cloudbees:maven-license-plugin
%pom_remove_plugin com.cloudbees:maven-license-plugin plugins
%pom_remove_plugin :maven-jenkins-dev-plugin
%pom_remove_plugin :maven-dependency-plugin core

# missing deps
%pom_remove_dep org.jenkins-ci.main:jenkins-test-harness plugins
%pom_remove_dep :animal-sniffer-annotations
%pom_remove_dep :animal-sniffer-annotations plugins
%pom_remove_dep org.jvnet.hudson:jtidy core
%pom_remove_dep org.jenkins-ci:core-annotation-processors core
%pom_remove_dep org.jruby.ext.posix:jna-posix core
%pom_remove_dep org.kohsuke.stapler:stapler-jrebel core
%pom_remove_dep org.kohsuke:windows-package-checker core
%pom_remove_dep org.kohsuke.stapler:stapler-adjunct-zeroclipboard core
%pom_remove_dep org.jvnet.hudson:activation core
%pom_remove_dep org.jvnet.winp:winp core
%pom_remove_dep org.codehaus.woodstox:wstx-asl core
%pom_remove_dep org.jvnet.libzfs:libzfs core
%pom_remove_dep com.sun.solaris:embedded_su4j core
%pom_remove_dep org.kohsuke.jinterop:j-interop core
%pom_remove_dep org.jenkins-ci.modules:windows-slave-installer war
%pom_remove_dep org.jenkins-ci.modules:launchd-slave-installer war
%pom_remove_dep org.jenkins-ci.modules:upstart-slave-installer war
%pom_remove_dep org.jenkins-ci.modules:systemd-slave-installer war
%pom_remove_dep org.jenkins-ci.modules:slave-installer war
%pom_remove_dep :maven-plugin war
%pom_remove_dep :test-annotations

#%%if %{bootstrap}
#%%endif
%pom_remove_plugin :maven-dependency-plugin war
#%%pom_xpath_remove "pom:plugin[pom:artifactId[text()='maven-dependency-plugin']]/pom:executions" war
%pom_remove_dep :cli war
%pom_add_dep org.bouncycastle:bcprov-jdk16 war
%pom_add_dep org.bouncycastle:bcpkix-jdk15on war
%pom_add_dep org.apache.sshd:sshd-core war '
<exclusions>
  <exclusion>
    <groupId>org.apache.tomcat</groupId>
    <artifactId>tomcat-coyote</artifactId>
  </exclusion>
</exclusions>'

# fix gId:aId
# findbugs annotations
%pom_remove_dep findbugs:annotations core
%pom_add_dep com.google.code.findbugs:jsr305 core
# groovy
%pom_remove_dep org.codehaus.groovy:groovy-all core
%pom_add_dep org.codehaus.groovy:groovy18:1.8 core
# jfreechart
%pom_remove_dep jfree:jfreechart core
%pom_add_dep org.jfree:jfreechart
# jelly-tags
%pom_remove_dep org.jvnet.hudson:commons-jelly-tags-define core
%pom_add_dep commons-jelly:commons-jelly-tags-define core

# jline 1.x is a compat package
%pom_remove_dep jline:jline core
%pom_add_dep jline:jline:1 core

%pom_change_dep org.codehaus.groovy:groovy18 : core '
<exclusions>
  <exclusion>
    <groupId>com.thoughtworks.xstream</groupId>
    <artifactId>xstream</artifactId>
  </exclusion>
  <exclusion>
    <groupId>org.apache.tomcat</groupId>
    <artifactId>tomcat-servlet-api</artifactId>
  </exclusion>
  <exclusion>
    <groupId>org.apache.tomcat</groupId>
    <artifactId>tomcat-jsp-api</artifactId>
  </exclusion>
</exclusions>'

%build
%mvn_build -f -X

%install
%mvn_install


# wrapper script for CLI
%jpackage_script hudson.cli.CLI "" "" trilead-ssh2:commons-codec:jenkins-remoting/remoting:localizer/localizer:jfreechart/jfreechart:jenkins/cli %{name}-cli true


%if !%{bootstrap}

install -d -m 755 %{buildroot}/%{homedir}
install -d -m 755 %{buildroot}/%{webroot}
install -d -m 755 %{buildroot}/%{homedir}/plugins
install -d -m 755 %{buildroot}/%{corepluginsdir}
install -d -m 755 %{buildroot}/%{workdir}
install -d -m 755 %{buildroot}/%{_localstatedir}/log/%{name}
install -d -m 755 %{buildroot}/%{_sysconfdir}/%{name}
install -d -m 755 %{buildroot}/%{_unitdir}
install -d -m 755 %{buildroot}/%{_libexecdir}/%{name}

install -m 644 %{SOURCE6} %{buildroot}/%{_unitdir}/%{name}.service
install -m 644 %{SOURCE7} %{buildroot}/%{_libexecdir}/%{name}/%{name}

# webapp
# we don't have packaging guidelines for web applications yet.
# just install exploded WAR to %{webroot}
unzip -d %{buildroot}/%{webroot}/ war/target/jenkins.war
pushd %{buildroot}/%{webroot}/WEB-INF/lib
    rm asm*-distroshaded-*.jar
    rm groovy18*.jar
    xmvn-subst .
    ln -sf `build-classpath objectweb-asm3/asm-tree-distroshaded` asm-tree-distroshaded-any.jar
    ln -sf `build-classpath objectweb-asm3/asm-util-distroshaded` asm-util-distroshaded-any.jar
    ln -sf `build-classpath objectweb-asm3/asm-distroshaded` asm-distroshaded-any.jar
    ln -sf `build-classpath objectweb-asm3/asm-commons-distroshaded` asm-commons-distroshaded-any.jar
    ln -sf `build-classpath objectweb-asm3/asm-analysis-distroshaded` asm-analysis-distroshaded-any.jar
    ln -sf `build-classpath groovy18-1.8` groovy18-1.8.jar
    ln -sf `build-classpath hsqldb1-1.jar` hsqldb-1.jar
    ln -sf `build-classpath jenkins/cli` cli-%{version}.jar
    ln -sf `build-classpath jenkins/jenkins-core` jenkins-core-%{version}.jar
    ln -sf `build-classpath jenkins-winstone/winstone` ../../winstone.jar
    ln -sf `build-classpath jenkins-executable-war/executable-war` ../../executable-war.jar
popd

cp %{SOURCE8} %{buildroot}/%{webroot}/WEB-INF/classes/dependencies.txt
# remove bundled YUI library
rm -Rf %{buildroot}/%{webroot}/scripts/yui

cp -p %{buildroot}/%{_javadir}/%{name}/cli.jar %{buildroot}/%{webroot}/WEB-INF/jenkins-cli.jar

install -d -m 755 %{buildroot}%{_sysconfdir}/sysconfig
cp -p %{SOURCE4} %{buildroot}%{_sysconfdir}/sysconfig/%{name}
%endif # bootstrap

%pre
# Add jenkins user and group
getent group %{name} >/dev/null || groupadd -f -g %{juid} -r %{name}
if ! getent passwd %{name} >/dev/null ; then
  if ! getent passwd %{juid} >/dev/null ; then
    useradd -r -u %{juid} -g %{name} -d %{workdir} -s /sbin/nologin -c "Jenkins Continuous Build server" %{name}
  else
    useradd -r -g %{name} -d %{workdir} -s /sbin/nologin -c "Jenkins Continuous Build server" %{name}
  fi
fi
exit 0

%post
%systemd_post %{name}.service

%preun
%systemd_preun %{name}.service

%postun
%systemd_postun_with_restart %{name}.service

%files core -f .mfiles-core
%dir %{_javadir}/%{name}
%doc LICENSE.txt LICENSE-ASL-2.0.txt LICENSE-CDDL.txt

%files
%defattr(0664, jenkins, jenkins, 0755)
%{_sysconfdir}/jenkins
%{_unitdir}/%{name}.service
%dir %{homedir}
%dir %{homedir}/plugins
%attr(0770, jenkins, jenkins) %{_libexecdir}/%{name}
%attr(0770, jenkins, jenkins) %{_localstatedir}/log/%{name}
%attr(0770, jenkins, jenkins) %dir %{workdir}

%files plugins-pom -f .mfiles-plugins-pom

%files cli -f .mfiles-cli
%{_bindir}/%{name}-cli
%doc LICENSE.txt

%if !%{bootstrap}
%files webapp
%{webroot}
%{corepluginsdir}
%config(noreplace) %{_sysconfdir}/sysconfig/%{name}
%doc LICENSE.txt
%endif # bootstrap

%files javadoc -f .mfiles-javadoc
%doc LICENSE.txt

%changelog
* Sun Mar 29 2015 Michal Srb <msrb@redhat.com> - 1.590-3
- Fix multiple CVEs:
- Resolves: CVE-2015-1806
- Resolves: CVE-2015-1807
- Resolves: CVE-2015-1813
- Resolves: CVE-2015-1812
- Resolves: CVE-2015-1810
- Resolves: CVE-2015-1808
- Resolves: CVE-2015-1809
- Resolves: CVE-2015-1814
- Resolves: CVE-2015-1811

* Mon Feb 02 2015 Michal Srb <msrb@redhat.com> - 1.590-2
- Require jna >= 4.1.0-7

* Wed Nov 19 2014 Michal Srb <msrb@redhat.com> - 1.590-1
- Update to upstream version 1.590
- Add R: jenkins-matrix-project-plugin

* Wed Nov 12 2014 Michal Srb <msrb@redhat.com> - 1.589-1
- Update to upstream version 1.589

* Wed Oct 01 2014 Michal Srb <msrb@redhat.com> - 1.581-3
- Fix JENKINS_HOME ownership (Resolves: rhbz#1147846)
- Do not inform about upstream core updates (Resolves: rhbz#1147897)
- Move webroot to %%{webroot}
- Own directory for core plugins
- Make jenkins-cli.jar available for download (Resolves: rhbz#1147831)
- Make slave.jar available for download (Resolves: rhbz#1147978)
- Exclude unneeded slf4j binding (Resolves: rhbz#1147875)
- Fix "Incorrect plugin version to downgrade" bug (Resolves: rhbz#1147908)
- Fix "RPM plugin uninstallation is not persistent" (Resolves: rhbz#1147902)

* Sun Sep 28 2014 Michal Srb <msrb@redhat.com> - 1.581-2
- Add R: jenkins-junit-plugin

* Mon Sep 22 2014 Michal Srb <msrb@redhat.com> - 1.581-1
- Update to upstream version 1.581
- Migrate to jenkins-winstone
- Initial support for plugins from RPMs
- Bugfixes

* Fri Aug 15 2014 Michal Srb <msrb@redhat.com> - 1.569-3
- Add R for webapp: jenkins-core and jenkins-cli

* Fri Jul 11 2014 Michal Srb <msrb@redhat.com> - 1.569-2
- Exclude unneeded JARs

* Thu Jun 26 2014 Michal Srb <msrb@redhat.com> - 1.569-1
- Update to upstream version 1.569

* Mon Jun 23 2014 Michal Srb <msrb@redhat.com> - 1.557-14
- Fix FTBFS

* Sun Jun 08 2014 Fedora Release Engineering <rel-eng@lists.fedoraproject.org> - 1.557-13
- Rebuilt for https://fedoraproject.org/wiki/Fedora_21_Mass_Rebuild

* Wed Apr 09 2014 Michal Srb <msrb@redhat.com> - 1.557-12
- Do not inherit default configuration from tomcat
- Tweak permissions

* Mon Apr 07 2014 Michal Srb <msrb@redhat.com> - 1.557-11
- Run as a separate service

* Mon Apr 07 2014 Michal Srb <msrb@redhat.com> - 1.557-10
- Remove forgotten BSD license references

* Fri Apr 04 2014 Michal Srb <msrb@redhat.com> - 1.557-9
- Update license tag to reflect changes in 1.557

* Fri Apr 04 2014 Michal Srb <msrb@redhat.com> - 1.557-8
- Drop unneeded trilead-ssh2 patch

* Fri Apr 04 2014 Michal Srb <msrb@redhat.com> - 1.557-7
- Spec file cleanup

* Fri Apr 04 2014 Michal Srb <msrb@redhat.com> - 1.557-6
- Remove superfluous JARs from cli jpackage script

* Fri Apr 04 2014 Michal Srb <msrb@redhat.com> - 1.557-5
- Use jline1

* Thu Apr 03 2014 Michal Srb <msrb@redhat.com> - 1.557-4
- Symlink remoting and cli JAR

* Wed Apr 02 2014 Michal Srb <msrb@redhat.com> - 1.557-3
- Build with stapler-adjunct-codemirror

* Tue Apr 01 2014 Michal Srb <msrb@redhat.com> - 1.557-2
- Allow symlinking

* Tue Apr 01 2014 Michal Srb <msrb@redhat.com> - 1.557-1
- Update to upstream version 1.557

* Mon Mar 31 2014 Michal Srb <msrb@redhat.com> - 1.549-8
- First acegisecurity experiment

* Mon Mar 31 2014 Michal Srb <msrb@redhat.com> - 1.549-7
- Symlink tomcat's work dir

* Thu Mar 27 2014 Michal Srb <msrb@redhat.com> - 1.549-6
- Unbundle yui
- Install proper sysconfig

* Thu Mar 27 2014 Michal Srb <msrb@redhat.com> - 1.549-5
- BR jenkins-core when building webapp

* Thu Mar 27 2014 Michal Srb <msrb@redhat.com> - 1.549-4
- Add missing BR

* Tue Mar 25 2014 Michal Srb <msrb@redhat.com> - 1.549-3
- Build webapp

* Tue Mar 11 2014 Michal Srb <msrb@redhat.com> - 1.549-2
- Fix license tag
- Install missing licenses
- Remove bundled jars and classes

* Wed Jan 29 2014 Michal Srb <msrb@redhat.com> - 1.549-1
- Initial packaging

